SetRootRule (Tomcat API Documentation)
Keywords: org.apache.tomcat.util.digester.SetRootRule class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tomcat.util.digester
Class SetRootRule

    java.lang.Object
      org.apache.tomcat.util.digester.Rule
          org.apache.tomcat.util.digester.SetRootRule

    public class SetRootRule

extends Rule

Rule implementation that calls a method on the root object on the stack, passing the top object (child) as an argument. It is important to remember that this rule acts on `end`.

This rule now supports more flexible method matching by default. It is possible that this may break (some) code written against release 1.1.1 or earlier. See `isExactMatch()` for more details.

Field Summary
`protected java.lang.String` | `methodName` The method name to call on the parent object.
`protected java.lang.String` | `paramType` The Java class name of the parameter type expected by the method.
`protected boolean` | `useExactMatch` Should we use exact matching.

Fields inherited from class org.apache.tomcat.util.digester.Rule
`digester, namespaceURI`

Constructor Summary
`SetRootRule(Digester digester, java.lang.String methodName)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetRootRule(String methodName)` instead.
`SetRootRule(Digester digester, java.lang.String methodName, java.lang.String paramType)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetRootRule(String methodName,String paramType)` instead.
`SetRootRule(java.lang.String methodName)` Construct a "set root" rule with the specified method name.
`SetRootRule(java.lang.String methodName, java.lang.String paramType)` Construct a "set root" rule with the specified method name.

Method Summary
`void` | `end()` Process the end of this element.
`boolean` | `isExactMatch()` Is exact matching being used.
`void` | `setExactMatch(boolean useExactMatch)` Set whether exact matching is enabled.
`java.lang.String` | `toString()` Render a printable version of this Rule.

Methods inherited from class org.apache.tomcat.util.digester.Rule
`begin, begin, body, body, end, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### methodName

    protected java.lang.String methodName

  The method name to call on the parent object.

### paramType

    protected java.lang.String paramType

  The Java class name of the parameter type expected by the method.

### useExactMatch

    protected boolean useExactMatch

  Should we use exact matching. Default is no.

Constructor Detail

### SetRootRule

    public SetRootRule(Digester digester,
                       java.lang.String methodName)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetRootRule(String methodName)` instead.

  Construct a "set root" rule with the specified method name. The method's argument type is assumed to be the class of the child object.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the parent method to call

### SetRootRule

    public SetRootRule(Digester digester,
                       java.lang.String methodName,
                       java.lang.String paramType)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetRootRule(String methodName,String paramType)` instead.

  Construct a "set root" rule with the specified method name.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the parent method to call
    `paramType` - Java class of the parent method's argument (if you wish to use a primitive type, specify the corresonding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

### SetRootRule

    public SetRootRule(java.lang.String methodName)

  Construct a "set root" rule with the specified method name. The method's argument type is assumed to be the class of the child object.

  Parameters:
    `methodName` - Method name of the parent method to call

### SetRootRule

    public SetRootRule(java.lang.String methodName,
                       java.lang.String paramType)

  Construct a "set root" rule with the specified method name.

  Parameters:
    `methodName` - Method name of the parent method to call
    `paramType` - Java class of the parent method's argument (if you wish to use a primitive type, specify the corresonding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

Method Detail

### isExactMatch

    public boolean isExactMatch()

  Is exact matching being used.

  This rule uses `org.apache.commons.beanutils.MethodUtils` to introspect the relevent objects so that the right method can be called. Originally, `MethodUtils.invokeExactMethod` was used. This matches methods very strictly and so may not find a matching method when one exists. This is still the behaviour when exact matching is enabled.

  When exact matching is disabled, `MethodUtils.invokeMethod` is used. This method finds more methods but is less precise when there are several methods with correct signatures. So, if you want to choose an exact signature you might need to enable this property.

  The default setting is to disable exact matches.

  Returns:
    true iff exact matching is enabled
  Since:
    Digester Release 1.1.1

### setExactMatch

    public void setExactMatch(boolean useExactMatch)

  Set whether exact matching is enabled.

  See `isExactMatch()`.

  Parameters:
    `useExactMatch` - should this rule use exact method matching
  Since:
    Digester Release 1.1.1

### end

    public void end()
             throws java.lang.Exception

  Process the end of this element.

  Overrides:
    `end` in class `Rule`
  Throws:
    `java.lang.Exception`

### toString

    public java.lang.String toString()

  Render a printable version of this Rule.

  Overrides:
    `toString` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.